# Contributing

Please be sure to read the contribution guidelines before making or requesting a change.

## Design Principles

Before anything please consider what are the main design principles of SLEEF:

1. Portability across platforms and architectures
2. Compliance with C99 standard
3. Best performance of vector implementation of branch-free and lookup-free algorithms

## Filing Issues or Requesting a Change

Before filing a report, please be sure to read the guidelines for what you are reporting:

* [Report Bugs](https://sleef.org/6-contribute#report-bugs)
* [Request Feature](https://sleef.org/6-contribute#request-feature)
* [Request a Change in Documentation](https://sleef.org/6-contribute#request-documentation)

## Contributing Code or Documentation

Before submitting code or documentation to SLEEF, please read over the [Pull Request Guidelines](https://sleef.org/6-contribute#pull-requests).

## Full Documentation

Our full contribution guidelines can be found at: <https://sleef.org/6-contribute>
